#include "Buffer.h"


	Buffer::Buffer(int d)
	{
		in=out=occupati=0;
		dim=d;
		ordini=new Ordine[dim];
	}

	bool Buffer:: isFull()
	{
		return (occupati==dim);
	}

	bool Buffer::isEmpty()
	{
		return (occupati==0);
	}

	bool Buffer::isPresent(int codiceOrdine)
	{
		for(int i=0; i<dim; i++)
		if(ordini[i].codiceOrdine==codiceOrdine) return true;
		return false;
	}

	void Buffer::putFIFO(int codicePizza, int codiceOrdine, int quantita)
	{
		ordini[in].setOrdine(codicePizza, codiceOrdine, quantita);
		occupati++;
		in=(in+1)%dim;
	}

	Ordine Buffer::getFIFO()
	{
		Ordine ordine;
		ordine.codicePizza=ordini[out].codicePizza;
		ordine.codiceOrdine=ordini[out].codiceOrdine;
		ordine.quantita=ordini[out].quantita;

		occupati--;
		out=(out+1)%dim;

		return ordine;
	}

	//Preleva un ordinativo di pizze corrispondenti ad un codice di ordinazione pari a
	//'cod' e cancella l'ordinazione corrispondente (in quanto esaudita)
	void Buffer::clean(int cod)
	{
		for(int i=0; i<dim; i++)
		{
			if(ordini[i].codiceOrdine==cod)
			{
				ordini[i].setOrdine(0,0,0);
				occupati--;
			}
		}
	}

	//Deposita una certa quantit di pizze aventi codice pari a 'codicePizza' nella prima
	//posizione libera del banco delle pizze non-FIFO.
	//La posizione libera corrisponde ad un ordine non ancora utilizzato, cio vuoto.
	void Buffer::put(int codicePizza, int codiceOrdine, int quantita)
	{
		int i=0;
		while(!ordini[i].isEmpty()) i++;

		ordini[i].setOrdine(codicePizza,codiceOrdine,quantita);
		occupati++;
	}

